--[[
This is the level loader class for colorsuck

First version: 10.07.2012


]]--

mapLoader = Core.class(Sprite)
local box2dObjects = {}


function mapLoader:init(mapNumber)


	-- Setup Box2D World
    --world = b2.World.new(0, 10, true)
    self.world = world
	
	
	-- Get Content Dimensions (Logical)
	self.screenW = application:getContentWidth()
	self.screenH = application:getContentHeight()
	
	-- Load Tiled Map
	local mapToLoad = TiledMap.new("maps/" ..mapNumber..".lua")
	
	-- Get Level Dimension 
	self.worldW = mapToLoad.worldWidth
	self.worldH = mapToLoad.worldHeight
	print("Level "..mapNumber.." loaded. Dimensions :".. self.worldW.."x"..self.worldH.." px")
	
	
	-- Load Box2D Objects (Non-static)
	--local enemyLayer = mapToLoad:getLayer("Enemies")
	local objectLayer = mapToLoad:getLayer("Objects")
	
	-- Loop thru all objects in Later and insert them to scene
	for i = 1, #objectLayer.objects do
	
	self:object(objectLayer.objects[i].x + objectLayer.objects[i].width/ 2, objectLayer.objects[i].y + objectLayer.objects[i].height/2, objectLayer.objects[i].width, objectLayer.objects[i].height)
								
	end
	print("Objects Added")
	self:addChild(mapToLoad)
	
	
	self:drawBoundaries(0,self.worldH/2,10, self.worldH)
	self:drawBoundaries(self.worldW/2,0, self.worldW,10)
	self:drawBoundaries(self.worldW, self.worldH/2,10, self.worldH)
	self:drawBoundaries(self.worldW/2, self.worldH, self.worldW,10)
	print("Level Boundries Drawn")

end



function mapLoader:object(x, y, width, height)
	local object = Shape.new()	
	object:beginPath()
	
	
	object:moveTo(-width/2, -height/2)
	object:lineTo(width/2, -height/2)
	object:lineTo(width/2, height/2)
	object:lineTo(-width/2, height/2)
	object:closePath()
	object:endPath()
	object:setPosition(x,y)
	
	--create box2d physical object
	
	local objectBody = self.world:createBody{type = b2.STATIC_BODY}
	
	objectBody:setPosition(object:getX(), object:getY())
	objectBody:setAngle(object:getRotation() * math.pi/180)
	
	local objectPoly = b2.PolygonShape.new()
	
	objectPoly:setAsBox(object:getWidth()/2, object:getHeight()/2)
	
	local objectFixture = objectBody:createFixture{shape = objectPoly, density = 1.0, 
	friction = 0.5, restitution = 0.5}
	
	object.body = objectBody
	object.body.name = "Object"
	
--	object.body.type = type
--	object.body.score = score
	
	--add to scene
	self:addChild(object)
	
	--return created object
	return object

	
end


function mapLoader:getBoundaries() -- Getter for Level Boundries
return self.worldW, self.worldH
end


function mapLoader:drawBoundaries(x, y, width, height)
	local wall = Shape.new()
	wall:beginPath()
	
	wall:moveTo(-width/2,-height/2)
    wall:lineTo(width/2, -height/2)
    wall:lineTo(width/2, height/2)
    wall:lineTo(-width/2, height/2)
    wall:closePath()
    wall:endPath()
    wall:setPosition(x,y)
	
	local wallBody = self.world:createBody{type = b2.STATIC_BODY}
	wallBody:setPosition(wall:getX(), wall:getY())
	wallBody:setAngle(wall:getRotation() * math.pi/180)
	local wallPoly = b2.PolygonShape.new()
	wallPoly:setAsBox(wall:getWidth()/2, wall:getHeight()/2)
	local wallFixture = wallBody:createFixture{shape = wallPoly, density = 1.0, friction = 0.1, restitution = 0,2}
	wall.body = wallBody
	wall.body.type = "wall"
	
	self:addChild(wall)
	
	--return wall
	
end