testScreen = Core.class(Sprite)
local Actors = {}



function testScreen:init()
	--create world instance
	self.world = world

	-- Load Level data and get boundaries
	mapLoader = mapLoader.new(1)	
	self.worldW, self.worldH = mapLoader:getBoundaries()	 
	
	-- Add Camera
	Camera = Camera.new( self.worldW, self.worldH  ) 
	
	
	-- Add Container Layers
	local backgroundLayer = Sprite.new()
	backgroundLayer.name = "BGL"
	local levelLayer = Sprite.new()
	levelLayer.name = "LVL"
	local foregroundLayer = Sprite.new()
	foregroundLayer.name = "FGL"
	
	
	-- Load for Parallax
	Camera:addLayer( {backgroundLayer , 0.7} )
    Camera:addLayer( {foregroundLayer, 1.5} )
	Camera:addLayer( {levelLayer, 1} )
	

	
	-- Background
	bg1 = Bitmap.new(Texture.new("images/bg1.png"),true)	
	bg2 = Bitmap.new(Texture.new("images/bg2.png"),true)
	
	Player = Player.new(120, 120)
	Player.name = "Player"
	table.insert(Actors, Player)
	
--------------------------------------------------------------------------------

	-- Camera
	--self:addChild(Camera)
	
	-- Containers
	self:addChild(backgroundLayer)
	self:addChild(levelLayer)
	self:addChild(foregroundLayer)
	
	-- BG & FG
	backgroundLayer:addChild(bg1)
	foregroundLayer:addChild(bg2)

	-- Level
	levelLayer:addChild(mapLoader)
	
	-- Player
	levelLayer:addChild(Player)
	Camera:track(Player)
	
	-- Debug Draw
	levelLayer:addChild(debugDraw)
	
	-- Control Pad
	controls = controls.new(60,470)
	stage:addChild(controls)
	
	
	
	-- Run world
	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
	-- Clear Enter_Frame on EXIT
	self:addEventListener("exitBegin", self.onExitBegin, self)
	


end


-- Run World

function testScreen:onEnterFrame() 
	
	
	world:step(1/60, 8, 3)  
	
	
	Camera:lookAt()
	Player:move(Player:getDirection())
	
	
	for i,v in ipairs(Actors) do
		
		if v.body then
			local body = v.body           
            local bodyX, bodyY = body:getPosition()         
				
			v:setPosition(bodyX, bodyY)       

			--sprite:setPosition(Player:currentPosition( self.worldW, self.worldH ) + bodyX, bodyY )     
			
            v:setRotation(body:getAngle() * 180 / math.pi)
			
		end
	end	
	
	--debugDraw:setPosition( Player:currentPosition( self.worldW, self.worldH ) )
end



function testScreen:onExitBegin()
	self:removeEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
end


